//-----------------------------------------------------------------------------
//  Include file for MPHY184.POV
//  Image: "Realms of Physics"
//  June 1997
//-----------------------------------------------------------------------------


#include "golds.inc"


#declare CapTex1 =
texture {
    pigment {
        image_map {
            gif "capmap1.gif"
        }
        translate <0,-0.8,0>
        scale <.5,0.6,1>
        rotate <0,60,0>
    }
}


#declare CapTex2 =
texture {
    pigment {  Gray60  }
    finish {  Phong_Dull  }
}


#declare CapTex3 =
texture {
    pigment {  SkyBlue }
    finish {  Phong_Dull  }
}


#declare Capacitor1 =
union {
    cylinder {
        <0,0.2,0>, <0,0.6,0>, 0.18
        texture { CapTex1 }
    }
    disc {
        <0,0.6+Eps,0>, y, 0.13
        pigment { color Gray40 }
    }
    cylinder {
        <0,-Eps,0.08>, <0,0.3,0.07>, 0.015
        texture { Soft_Silver }
    }
    cylinder {
        <0,-Eps,-0.08>, <0,0.3,-0.07>, 0.015
        texture { Soft_Silver }
    }
}


#declare Capacitor2 =
union {
    cylinder {
        <0,0.2,0>, <0,0.6,0>, 0.18
        texture { CapTex2 }
    }
    disc {
        <0,0.6+Eps,0>, y, 0.13
        pigment { color Silver }
    }
    cylinder {
        <0,-Eps,0.08>, <0,0.3,0.07>, 0.015
        texture { Soft_Silver }
    }
    cylinder {
        <0,-Eps,-0.08>, <0,0.3,-0.07>, 0.015
        texture { Soft_Silver }
    }
}


#declare Capacitor3 =
union {
    cylinder {
        <0,0.2,0>, <0,0.5,0>, 0.14
        texture { CapTex3 }
    }
    disc {
        <0,0.5+Eps,0>, y, 0.12
        texture { T_Gold_1A }
    }
    cylinder {
        <0,-Eps,0.08>, <0,0.3,0.07>, 0.015
        texture { Soft_Silver }
    }
    cylinder {
        <0,-Eps,-0.08>, <0,0.3,-0.07>, 0.015
        texture { Soft_Silver }
    }
}


//-------------------------- capacitors --------------------------------------

object {
    Capacitor1
    rotate y*90
    translate <6.5,0,-1.8>
}


object {
    Capacitor1
    translate <1.9,0,-4.5>
}


object {
    Capacitor1
    rotate y*90
    translate <3.2,0,-7.8>
}


object {
    Capacitor2
    translate <2.2,0,-2>
}


object {
    Capacitor2
    translate <5.2,0,-5.5>
}


object {
    Capacitor3
    translate <1.2,0,-6>
}


object {
    Capacitor3
    translate <4.4,0,-2.5>
}

