//-----------------------------------------------------------------------------
//  Include file for MPHY184.POV
//  Image: "Realms of Physics"
//  June 1997
//-----------------------------------------------------------------------------



#if ( SimplifyPlasma = off )

#declare PlasmaTex =
texture {
    pigment {
        rgbf<1,1,1,1>
    }
    halo {
        emitting
        linear
        cylindrical_mapping
        turbulence <0.7,0,0.7>
        color_map {
              [ 0.0 color DarkSlateBlue transmit 1 ]
              [ 0.2 color Blue transmit 0.85 ]
              [ 0.4 color Cyan transmit 0.5 ]
              [ 0.7 color NeonPink transmit 0.3 ]
              [ 0.708 color NeonPink transmit 0.3 ]
              [ 0.75 color White*0.8 + Cyan*0.2 transmit 0.15 ]
        }
        samples 10
    }
    rotate <0,0,90>
}

#end



#declare PlasmaTube =
cylinder {
    <-8,0,0>, <0,0,0>, 1
#if ( SimplifyPlasma = off )
    texture { PlasmaTex }
#else
    pigment { color Cyan }
#end
    hollow
    scale <1,0.1,0.1>
}



object {
    PlasmaTube
    translate <0,0,-7.6>
}

object {
    PlasmaTube
    translate <0,0,-8>
}

object {
    PlasmaTube
    translate <0,0,-8.4>
}

object {
    PlasmaTube
    translate <0,0,-8.8>
}

object {
    PlasmaTube
    translate <0,0,-9.35>
}

object {
    PlasmaTube
    translate <0,0,-9.75>
}


